#ifndef _OPTION_MACROS_H_
#define _OPTION_MACROS_H_
/*
 *   $RCSfile: option_macros.h,v $  
 *   $Revision: 1.2 $  
 *   $Date: 1992/11/27 16:46:18 $      
 */ 
#ifndef __OPTION_MACROS_H__
#define __OPTION_MACROS_H__


/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/*
 * option.h
 *
 * classes, defines, typedefs, etc. for command line and resource file
 * option processing
 */

/*   Error return codes: */
#define OPTERR_Success			0
#define OPTERR_InternalError	-1
#define OPTERR_DefaultNeeded	-2
#define OPTERR_IllegalDescLine	-3
#define OPTERR_IllegalClass		-4
#define OPTERR_ClassTooLong		-5
#define OPTERR_TooManyClasses	-6
#define OPTERR_Duplicate		-7
#define OPTERR_NoMatch			-8
#define OPTERR_Syntax			-9


#define MAXOPTLENGTH 			256
#define MAXOPTCLASSIFICATION 	10
#define MAXOPTCLASSLENGTH 		(1000+MAXOPTCLASSIFICATION)


#endif __OPTION_MACROS_H__
#endif /* _OPTION_MACROS_H_ */
