#ifndef _RESOURCES_H_
#define _RESOURCES_H_
/*
 *   $RCSfile: resources.h,v $  
 *   $Revision: 1.2 $  
 *   $Date: 1992/11/27 16:46:21 $      
 */ 
#ifndef __RESOURCES_H__
#define __RESOURCES_H__

/**********************************************************************
* EXODUS Database Toolkit Software
* Copyright (c) 1991 Computer Sciences Department, University of
*                    Wisconsin -- Madison
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY OF WISCONSIN --
* MADISON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  
* THE DEPARTMENT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The EXODUS Project Group requests users of this software to return 
* any improvements or extensions that they make to:
*
*   EXODUS Project Group 
*     c/o David J. DeWitt and Michael J. Carey
*   Computer Sciences Department
*   University of Wisconsin -- Madison
*   Madison, WI 53706
*
*	 or exodus@cs.wisc.edu
*
* In addition, the EXODUS Project Group requests that users grant the 
* Computer Sciences Department rights to redistribute these changes.
**********************************************************************/

/* 
 * Identities of the various lists, etc.
 * Each list,hashtable,pool,etc.  must have a unique ID,
 * regardless of its location or use.
 * Well, "must" is not quite right, but if they are unique,
 * there will be no problems.
 */
#define LRCCACHE_POOL   1
#define LRCCACHE	 	2
#define PAGEHASH_POOL   3
#define PAGEHASH_TABLE  4
#define DIRTY_LIST  	5	/* dirtyList, clientDirtyList */
#define MEMBER_LIST  	6
#define DIRTYPAGETABLE  7
#define VOLREC_POOL  	8
#define VOLREC_TABLE  	9

#ifndef SERVER_MAKE
	/* client only */

#define SERVERINFO_POOL  10
#define SERVERINFO_TABLE 11
#define SERVERTRANS_POOL  12

#else
	/* server only */
#define VOLNAMEREC_POOL  	10
#define VOLNAME_TABLE  	11
#define VOLID_TABLE  	12

#endif

#endif __RESOURCES_H__
#endif /* _RESOURCES_H_ */
