#ifndef _FUNC_H_
#define _FUNC_H_
/*
 * $RCSfile: func.h,v $
 * $Revision: 1.23 $
 * $Date: 1993/05/06 20:35:51 $
 */
/* function prototypes of those used by et */

BEGIN_EXTERNC

extern int bf_FlushAll(); 

BOOL isDestroyed(ObjInfo*,  int);
BOOL varError(int , int , int , int , int , int *, int *, int *, int *);
BOOL validObjNum(int , int );
void printStats(BOOL, SERVERSTATS *);
void readOVF(int, ObjInfo *, int *, FILE *);
void writeOVF(int, ObjInfo *, int , FILE *);
void shut_sm();
VarType * createVar( char *);
BOOL existVar( char *, VarType **);
BOOL getString(char *, char *, BOOL );
BOOL dollarExist(char *);
void cleanLine(char *);
BOOL replaceDollars(char *);
void listVar();
void freeVar();
void fillUA(ObjInfo *, int , int , int );
void printArray (ObjInfo *, int );
void printobj (int, ObjInfo *);
int copyArrays(ObjInfo *, ObjInfo *, int );
void mark_temp_objects_destroyed(ObjInfo *, int );
void check_no_temp_objects(ObjInfo *, int );
BOOL diffObjHdr(OBJHDR *, OBJHDR *, BOOL , int );
int validate(int , int , int , ObjInfo *);


void setVar(char *, char *);
char *formPattern(char *, int , int );
extern int doRootEntry(VOLID , FID *, BOOL, int);
extern void SetVolid(OID *); 
extern	void	configFile();
extern void getnewline();
void echo(int , char *);
int getnum(char *, int *);
int word2index( char *);
int word2cmd( char *);
char *cmd2word(int);
char *index2word(int);
int	set_randop(char *);
void	print_randop();
void	init_scan();
void ignore_restofline();
void echo_random(int , int , char *);
void open_script(char *);
void close_script();

void    doAbort( BOOL *);
void 	checkStatus(BOOL);
void	restart_starts_here();
void	restart();
BOOL 	connect2server(VOLID, int );
int		begin_tx(BOOL, BOOL);
int		commit_tx();
int		prepare_tx();
int		enter2pc(char *);
int		continue2pc(char *);
int		_continue2pc(BOOL);
int		recover2pc(int, char *);
int		command2pc(int);
BOOL	abort_tx(BOOL);
BOOL	_abort_tx(BOOL, BOOL);
VOLID	 add_volid(char *);
int 	do_command(int );
int		get_command(int , BOOL );
void	add_evolids();
void	use_evolids();
VOLID *get_serverlist (FLAGS *);
int 	checkSum(char *, int );
int	 	scanFile(FID *, BOOL, BOOL, BOOL, ObjInfo *, int);
int		open_echofile(char *);
char 	*first_commandarg( char *);
char 	*next_commandarg( char *);
char 	*next_word(char *, char *);
int		set_seed(char *);
void	print_seed();
int		set_volid(char *);
VOLID	get_volid();
void	print_volid();
void	print_objsizelimit();
int 	set_objsizelimit(char *);
FID		*get_fid();
FID		*get_fid_of(VOLID);
void	mark_used(VOLID);
int 	find_volid_index(VOLID);
int 	volumeStatus(BOOL, int, int);
ObjInfo	*oid2objinfo(OID *, ObjInfo *, int );
void 	clear_visited(ObjInfo *, int );
void 	check_visited(ObjInfo *, int, VOLID );
void 	set_visited(ObjInfo *);
void	dismount();
void	reinit_volid(int);
void	gettemp(VOLID, int, int);
BOOL	istemp(VOLID);
void	mark_temp_volumes_empty();
int		set_loglevel(char *);
void	initializeSM(BOOL);
int 	open_ovf( char *ovfName, BOOL ovfMustExist );
void 	printUA();
void 	printCA();

extern jmp_buf  where;
extern BOOL	ok2retry;
int setjmpretval;
#define retry(a) { \
	DEBUGINFO "retry from line %d, file %s\n", __LINE__, __FILE__ ENDINFO \
	if( ok2retry ) { \
		DEBUGINFO "longjmp from line %d file %s\n",__LINE__,__FILE__ ENDINFO \
		longjmp(where, (a)); \
	} \
	DEBUGINFO "not ok to retry at line %d file %s\n",__LINE__,__FILE__ ENDINFO \
}
#define clr_retry() {\
	DEBUGINFO "clr retry at line %d file %s\n", __LINE__, __FILE__ ENDINFO \
	ok2retry = FALSE; \
}
#define set_retry() {\
	DEBUGINFO "set retry at line %d, file %s\n", __LINE__, __FILE__ ENDINFO \
	if((setjmpretval = setjmp(where)) == 0) {\
		DEBUGINFO "ok2retry\n" ENDINFO\
		ok2retry = TRUE;\
	} else {\
		DEBUGINFO "clr retry on return from setjmp line %d file %s\n", __LINE__ , __FILE__ ENDINFO \
		ok2retry = FALSE;\
	}\
}

BOOL	connection_error(int);
void	clear_connect_error();

BOOL	probe_handle();
int  	checkMalloc(char *, BOOL);
void  	freePatternBuf();
void  	closebg();
void 	checkNumBufs(int, char *, BOOL );
void 	compareNumBufs(int, char *, int, char *);
int 	getNumBufs();
void	begin_tx_bufs(TID);
void	end_tx_bufs(TID);
int		count_objs_in_files(BOOL, ObjInfo *, int);

int	 	mstats(char *, int );
#if defined(mips) && defined(CHECKMALLOC)
int	 	_mstats(char *, int, u_int *);
void 	_free(char *, u_int *);
char	*_malloc(int, u_int *);
#endif 

END_EXTERNC

#if defined(mips) && defined(CHECKMALLOC)
extern u_int	amalloc[];

#define malloc(sz) _malloc(sz, &amalloc[0])
#define calloc(sz,num)	_malloc((sz)*(num), &amalloc[0])
#define free(cp)	_free((char *)cp, &amalloc[0])
#endif 

#endif /* _FUNC_H_ */
